# Tests by default. No tests: rpmbuild -ba --define 'dotests 0' *.spec

%{!?dotests: %define dotests 1}
Summary: Bidirectional data relay between two data channels ('netcat++')
Name: socat
Version:	1.8.0.0
Release:	1
License: GPLv2
URL:  https://www.dest-unreach.org/%{name}
Source0:	https://www.dest-unreach.org/socat/download/socat-%{version}.tar.bz2
Patch0: %{name}-1.7.3.2-aix.patch
Patch1: %{name}-1.8.0-xio-pty.patch
Patch2: %{name}-1.8.0-test.patch
Group: Applications/Internet

BuildRequires:	patch >= 2.7.6
BuildRequires:	gcc >= 10.3.0
BuildRequires:	readline-devel >= 8.2

Requires:	bash >= 5.2.15
Requires:	readline >= 8.2

%description
Socat is a relay for bidirectional data transfer between two independent data
channels. Each of these data channels may be a file, pipe, device (serial line
etc. or a pseudo terminal), a socket (UNIX, IP4, IP6 - raw, UDP, TCP), an
SSL socket, proxy CONNECT connection, a file descriptor (stdin etc.), the GNU
line editor (readline), a program, or a combination of two of these.


%prep
%setup -q
%patch0
%patch1
%patch2

mkdir ../32bit
mv  * ../32bit
mv ../32bit .
mkdir 64bit
cp -r 32bit/* 64bit

%build
export CFLAGS=" -maix64 -O2 -DHAVE_FLOCK -DSYSV -D_ALL_SOURCE -DFUNCPROTO=15 -I/opt/freeware/include"

cd 64bit
export OBJECT_MODE=64
export CC="%{__cc__}"
export LDFLAGS="-L/opt/freeware/lib64 -L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib64:/opt/freeware/lib:/usr/lib:/lib"
./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --enable-help \
    --enable-stdio \
    --enable-fdnum \
    --enable-file \
    --enable-creat \
    --enable-gopen \
    --enable-pipe \
    --enable-termios \
    --enable-unix \
    --enable-ip4 --enable-ip6 \
    --enable-rawip \
    --enable-tcp --enable-udp \
    --enable-listen \
    --enable-proxy \
    --enable-exec \
    --enable-system \
    --enable-pty \
    --enable-readline \
    --enable-openssl \
    --enable-sycls \
    --enable-filan \
    --enable-retry \
    --enable-libwrap \
    --enable-fips

gmake %{?_smp_mflags}
if [ "%{dotests}" == 1 ]
      then
          (gmake -k test || true)
fi
     
cd ../32bit
export OBJECT_MODE=32
export CC="%{__cc__}"
export CFLAGS="-maix32 -O2 -D_LARGE_FILES -DHAVE_FLOCK"
export LDFLAGS="-L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
     
./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --enable-help \
    --enable-stdio \
    --enable-fdnum \
    --enable-file \
    --enable-creat \
    --enable-gopen \
    --enable-pipe \
    --enable-termios \
    --enable-unix \
    --enable-ip4 --enable-ip6 \
    --enable-rawip \
    --enable-tcp --enable-udp \
    --enable-listen \
    --enable-proxy \
    --enable-exec \
    --enable-system \
    --enable-pty \
    --enable-readline \
    --enable-openssl \
    --enable-sycls \
    --enable-filan \
    --enable-retry \
    --enable-libwrap \
    --enable-fips

gmake %{?_smp_mflags}     
if [ "%{dotests}" == 1 ]
      then
          (gmake -k test || true)
      fi

%install
#[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}
#make DESTDIR=${RPM_BUILD_ROOT} install

#/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :

cd 64bit
export OBJECT_MODE=64
export AR="/usr/bin/ar -X64"
gmake DESTDIR=${RPM_BUILD_ROOT} install

/usr/bin/strip ${RPM_BUILD_ROOT}%{_bindir}/* || :
          (
             cd ${RPM_BUILD_ROOT}%{_bindir}
            for f in $(ls -1| grep -v -e _32 -e _64)
            do
              mv ${f} ${f}_64
            done
         )
    
cd ../32bit
export OBJECT_MODE=32
export AR="/usr/bin/ar -X32"
gmake DESTDIR=${RPM_BUILD_ROOT} install

/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :
         (
            cd ${RPM_BUILD_ROOT}%{_bindir}
            for f in $(ls -1| grep -v -e _32 -e _64)
          do
            mv ${f} ${f}_32
             ln -sf ${f}_64 ${f}
           done
         )

%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system)
%doc 32bit/BUGREPORTS 32bit/CHANGES 32bit/DEVELOPMENT 32bit/EXAMPLES 32bit/FAQ 32bit/PORTING
%doc 32bit/COPYING* 32bit/README 32bit/SECURITY 
%doc 32bit/daemon.sh 32bit/ftp.sh 32bit/mail.sh 32bit/proxy.sh
%doc 32bit/proxyecho.sh 32bit/readline.sh 32bit/readline-test.sh
%doc 32bit/socks4echo.sh 32bit/socks4a-echo.sh 32bit/test.sh
%{_bindir}/*
%{_mandir}/man1/*


%changelog
* Thu Jun 20 2024 Shubham Gupta <shubham.gupta36@ibm.com> - 1.8.0.0-1 
- Update to version 1.8.0.0

* Thu Sep 02 2021 Raghu N Arava <raghuara@in.ibm.com> - 1.7.4.3-1
- Update to version 1.7.4.3

* Thu Sep 02 2021 Reshma V Kumar <reskumar@in.ibm.com> - 1.7.4.1-1
- Update to version 1.7.4.1

* Wed Apr 29 2020 Baanu Tumma <btumma15@in.ibm.com> - 1.7.3.4-1
- Updated to version 1.7.3.4-1

* Fri Nov 09 2018 Harshita Jain <harjain9@in.ibm.com> - 1.7.3.2-1
- Updated to version 1.7.3.2-1

* Wed Jun 13 2018 Michael Perzl <michael@perzl.org> - 1.7.3.2-1
- updated to version 1.7.3.2

* Wed Nov 16 2016 Michael Perzl <michael@perzl.org> - 1.7.3.1-2
- recompiled against latest versions

* Mon May 02 2016 Michael Perzl <michael@perzl.org> - 1.7.3.1-1
- updated to version 1.7.3.1

* Fri Mar 04 2016 Michael Perzl <michael@perzl.org> - 1.7.3.0-2
- recompiled against latest version of openssl

* Thu Apr 02 2015 Michael Perzl <michael@perzl.org> - 1.7.3.0-1
- updated to version 1.7.3.0

* Mon Mar 10 2014 Michael Perzl <michael@perzl.org> - 1.7.2.4-1
- updated to version 1.7.2.4

* Wed Jan 29 2014 Michael Perzl <michael@perzl.org> - 1.7.2.3-1
- updated to version 1.7.2.3

* Fri Jun 21 2013 Michael Perzl <michael@perzl.org> - 1.7.2.2-1
- first version for AIX V5.1 and higher

